ЧТО ЭТО ? (about)
=================

make-initrd - это реализация создания образов initramfs. Проект состоит из
двух основных частей:
* утилиты создания образа initramfs (make-initrd);
* утилит, работающих внутри образа в момент загрузки (назовём их initrd/init).

Утилита создания образа имеет модульную структуру. Оснавная её идея, что
для создания образа необходимо (в простейшем случае) указать список
особенностей (фич) будущего образа. При этом порядок указания совершенно не важен.
Пользователь не обязан знать как и в каком порядке будут применяться стадии. Ему
важно, чтобы, например, образ имел нужные модули, имел bootspalsh и был сжат.

Для своей работы make-initrd использует GNU make, чтобы легко создавать и правильно
обрабатывать зависимости между модулями.

ПАРАМЕТРЫ (parameters)
======================

Параметры указываются в файле /etc/initrd.mk. Этот файл является конфигурационным
файлом для make-initrd.

KERNEL        - Устанавливает версию ядра, для которого будет собираться образ.

IMAGEFILE     - Файл, в который должен быть записан образ.

COMPRESS      - Определяет способ сжатия образа. Допустимые значения:
                gzip, bzip2, lzma, lzo.
                Если переменная имеет пустое значение, то сжатие производиться
                не будет.
                (см. раздел ОСОБЕННОСТИ).

FEATURES      - Этот параметр перечисляет список особенностей образа. Этот
                список может быть указан в произвольном порядке.
                (см. раздел ОСОБЕННОСТИ).

                Например: FEATURES = autodetect compress cleanup

                Список указывает, что для образа нужно произвести автоматический
                поиск модулей, сжать образ определённым способом, а затем
                необходимо удалить все временные файлы от создания образа.

AUTODETECT    - В этой переменной перечисляются подсистемы, для которых
                автоматичеки будут находиться модули ядра. В данный момент
                доступны следующие мождули:

                root  - будут найдены модули для устройства, на котором находится
                        корневая файловая система и модули самой файловой системы
                        (если они не собраны в ядро);

                net   - будут добавлены модули ядра для загрузки сетевых устройств
                        (в терминах sysfs это /sys/class/net/*).
                        Вы можете указать дополнительные параметры, чтобы добавить
                        модули только для определённого сетевого интерфейса:

                        net:<iface>   - указывает имя интерфейса, для которого
                                        будет добавлен модуль ядра;

                        net:mac=<MAC> - указывает MAC-адрес интерфейса. Вы можете
                                        использовать шаблон shell для поиска имени.

                input - будут добавлены модули для input устройств (в терминах
                        sysfs это /sys/class/input/*).
                        Вы можете указать дополнительные параметры:

                        input:<name>    - указывает имя устройства 
                                          (/sys/class/input/<name>),для которого
                                          будет добавлен модуль ядра.

                        input:name=TEXT - указывает имя устройства
                                          (/sys/class/input/*/name). Вы также можете
                                          использовать шаблоны shell.

                (см. раздел ОСОБЕННОСТИ).

MODULES_ADD   - Параметр перечисляет имена модулей, которые должны быть
                добавлены в образ.
                (см. раздел ОСОБЕННОСТИ).

MODULES_LOAD  - Параметр перечисляет имена модулей, которые должны быть
                добавлены в образ и загружены ПОСЛЕ старта udevd.
                (см. раздел ОСОБЕННОСТИ).

MODULES_PRELOAD - Параметр перечисляет имена модулей, которые должны быть
                добавлены в образ и загружены ДО старта udevd.
                (см. раздел ОСОБЕННОСТИ).

VERBOSE       - Включает отладочную информацию.

FIRMWARE_DIRS - В этой переменной перечислены директории, в которых будут
                искаться firmware.

ОСОБЕННОСТИ (features)
======================

Особенности - это части функционала, который выполняется при создании образа или
в ходе его работы во время загрузки (см. FEATURES).

add-modules   - Установить (см. MODULES_ADD) или установить и добавить к загрузке 
                (см. MODULES_LOAD, MODULES_PRELOAD) дополнительные модули ядра.

autodetect    - Включить режим автоматического определения необходимых в процессе
                загрузки модулей.

bootsplash    - Добавить в образ splash.

lvm           - Добавить в образ утилиты для загрузки корневой файловой системы с LVM.

compress      - Сжать образ определённым алгоритмом (см. COMPRESS).

cleanup       - Удалить временные файлы, созданные make-initrd в процессе создания образа.
                Иногда очень удобно посмотреть что и как было создано.

Структура каталогов
===================

autodetect - Здесь находятся модули автоматического определения модулей ядра.

features   - Каталог содержит параметры и правила различных особенностей.

data       - Тут находятся скрипты, выполняющиеся в процессе загрузки.

docs       - Каталог с документацией.

tools      - Здесь находятся вспомогательные утилиты.

src        - Также вспомогательные утилиты, но реализованные на Си.

             gen_init_cpio - Эта утилита взята из ядра. Она позволяет создавать
                             cpio образ.

             ls - минимальная реализация ls для klibc. Необходима для отладки в
                  процессе загрузки.

             printenv - минимальная реализация printenv для klibc.

             replace - некое подобие tr для klibc. Утилита заменяет символы,
                       умеет понимать примитивные перечисления, а также умеет
                       квотировать символы.

legion 2009
