# System paths
WORKDIR		?= /tmp/initrd-$(KERNEL).work
ROOTDIR		?= $(WORKDIR)/root

TOOLSDIR	 = /usr/share/make-initrd/tools
DATADIR		?= /usr/share/make-initrd/data
SCRIPTDIR	?= /usr/share/make-initrd/scripts.d
FEATURESDIR	?= /usr/share/make-initrd/features
AUTODETECTDIR	?= /usr/share/make-initrd/autodetect

HELPERSDIR	?= $(TOOLSDIR)

# Helpers
GEN_INIT_CPIO		= /usr/bin/gen_init_cpio
CREATE_INITRD		= $(TOOLSDIR)/create-initrd
PACK_IMAGE		= $(TOOLSDIR)/pack-image
ADD_MODULE		= $(TOOLSDIR)/add-module
LOAD_MODULE		= $(TOOLSDIR)/load-module
ADD_RESCUE_MODULES	= $(TOOLSDIR)/add-rescue-modules
PUT_FILE		= $(TOOLSDIR)/put-file
PUT_TREE		= $(TOOLSDIR)/put-tree

# Global variables
FIRMWARE_DIRS		?= /lib/firmware /usr/lib/hotplug/firmware /usr/local/lib/firmware
VERBOSE			?=
FSTAB			?= /etc/fstab

# User defaults
FEATURES	?=
KERNEL		?= $(shell uname -r)
IMAGEFILE	?= /boot/initrd-$(KERNEL).img

# Load extra configs
include $(FEATURESDIR)/*/config.mk

ifdef VERBOSE
  verbose=-v
  Q=
else
  Q = @
endif

